/* All the happy includes, typedefs, and evil globals.. :) */

#include <gdk_imlib.h>
#include <gdk/gdkprivate.h>
#include <gtk/gtk.h>

#include <sys/types.h>
#include <ctype.h>
#include <fcntl.h>
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <unistd.h>
#include <time.h>
#include <Xlib.h>

				/* Digicam Libraries */
#include <eph_io.h>		/* PhotoPC */

				/* Images */
#include "splash.xpm"		/* Splash screen  */

#include "fileopen.xpm"		/* Toolbar icons  */
#include "print.xpm"
#include "getindex.xpm"
#include "getpic.xpm"
#include "deletepic.xpm"
#include "cameraconfig.xpm" 

#include "rotc.xpm"		/* Image Manipulation icons */
#include "rotcc.xpm"		/* I think we need better   */
#include "fliph.xpm"		/* icons for these.. :)	    */
#include "flipv.xpm"
#include "resize.xpm"

				/* Big happy title and version # */
#define   TITLE_VER	"GNU Photo (gphoto) - v0.1 Developer's Release"


				/* function pointers 		*/
typedef GdkImlibImage* 	(*_get_picture)			(int,int);
typedef GdkImlibImage*	(*_get_preview)			();
typedef int 		(*_delete_picture)		(int);
typedef int 		(*_take_picture)		();
typedef int 		(*_number_of_pictures)		();
typedef int 		(*_configure)			();

struct _Camera {
	_get_picture	get_picture;
	_get_preview 	get_preview;
	_delete_picture delete_picture;
	_take_picture	take_picture;
	_number_of_pictures number_of_pictures;
	_configure	configure;
};

struct _Camera *Camera;

struct Model {
	char *name;
	struct _Camera *library;
};

				/* EEK!!! GLOBALS!!! AHHHHH!!! */

eph_iob   *iob;                 /* Digicam io-buffer		*/
GtkWidget *status_bar;		/* Main window status bar	*/
GtkWidget *notebook;            /* Main window Notebook		*/
GtkWidget *index_table;         /* Index table			*/
GtkWidget *index_window;	/* Index Scrolled Window        */
GtkWidget *progress;		/* Progress bar			*/
int	  picCounter=1;		/* Whenever gPhoto needs a #	*/
char      *gphotoDir;		/* gPhoto directory		*/
char	  serial_port[80];	/* Serial port			*/
char	  camera_model[100];	/* Currently selected cam model */

				/* Linked list node structure.	*/
struct ImageInfo {
	GdkImlibImage *imlibimage;
	GtkWidget *image;
	GtkWidget *button;
	GtkWidget *page;
	char 	  *info;
	struct 	  ImageInfo *next;
};

				/* The head nodes of the Image	*/ 
				/* Thumbnail linked lists.	*/
struct ImageInfo Images;
struct ImageInfo Thumbnails;

				/* Config globals are all gone... (yay) */

/* Prototypes ----------------	*/

void update_status(char *newStatus);
				/* Sets the status bar text	*/

void update_progress(float percentage);
				/* Sets the progress bar	*/

void error_dialog(char *Error);
				/* Simple Dialog w/ OK button	*/

void configure_call();
				/* Calls the camera config	*/

void del_dialog();
				/* Delete pictures confirmation	*/

void appendpic (int picNum, int fromCamera, char *fileName);
				/* Appends a picture to the notebook */

void destroy (GtkWidget *widget, gpointer data);
				/* gtk Destroy function		*/

void save_port(GtkWidget *widget, GtkWidget *dialog);
				/* Saves port dialog selection	*/

void port_dialog();
				/* Port/camera dialog		*/

void version_dialog();
				/* Version dialog		*/

void usersmanual_dialog();
				/* Manual dialog		*/

void faq_dialog();
				/* FAQ dialog			*/

void about_dialog();
				/* About dialog			*/

void menu_selected (gchar *toPrint);
				/* Says "blah not implemented"	*/

void remove_thumbnail (int i);
				/* removes thumbnail from linked list */

void getindex ();
				/* retrieves the index		*/

void getpics ();
				/* gets the selected pictures	*/

void remove_image(int i);
				/* kills image from linked list	*/

void closepic ();
				/* closes currently opened pic 	*/

void savepic (GtkWidget *widget, GtkFileSelection *fwin);
				/* saves currently viewed pic	*/

void openpic (GtkWidget *widget, GtkFileSelection *fwin);
				/* loads pic from disk		*/

void filedialog (gchar *a);
				/* generic file-dialog function */

void ok_click (GtkWidget *widget, GtkWidget *dialog);
				/* read the comments for info	*/
void send_to_gimp ();
				/* sends current pic to gimp	*/

void print_pic ();
				/* prints current pic		*/

void select_all();
				/* selects all index thumbnails	*/

void select_none();
				/* selects no index thumbnails	*/

void select_inverse();
				/* selects opposite thumbnails 	*/
